FLTK 1.4.5: Fl_RGB_Image Class Reference

FLTK 1.4.5

Loading...
Searching...
No Matches
Fl_RGB_Image Class Reference

The Fl_RGB_Image class supports caching and drawing of full-color images with 1 to 4 channels of color information. More...

`#include <Fl_Image.H>`

Inheritance diagram for Fl_RGB_Image:

## Public Member Functions
virtual Fl_SVG_Image * | as_svg_image ()
| Returns whether an image is an Fl_SVG_Image or not.
int | cache_h ()
int | cache_w ()
void | color_average (Fl_Color c, float i) FL_OVERRIDE
| The color_average() method averages the colors in the image with the provided FLTK color value.
Fl_Image * | copy () const
Fl_Image * | copy (int W, int H) const FL_OVERRIDE
| Creates a resized copy of the image.
void | desaturate () FL_OVERRIDE
| The desaturate() method converts an image to grayscale.
void | draw (int X, int Y)
void | draw (int X, int Y, int W, int H, int cx=0, int cy=0) FL_OVERRIDE
| Draws the image to the current drawing surface with a bounding box.
| Fl_RGB_Image (const Fl_Pixmap *pxm, Fl_Color bg=FL_GRAY)
| The constructor creates a new RGBA image from the specified Fl_Pixmap.
| Fl_RGB_Image (const uchar *bits, int bits_length, int W, int H, int D, int LD)
| The constructor creates a new image from the specified data.
| Fl_RGB_Image (const uchar *bits, int W, int H, int D=3, int LD=0)
| The constructor creates a new image from the specified data.
void | label (Fl_Menu_Item *m) FL_OVERRIDE
| This method is an obsolete way to set the image attribute of a menu item.
void | label (Fl_Widget *w) FL_OVERRIDE
| This method is an obsolete way to set the image attribute of a widget or menu item.
virtual void | normalize ()
| Makes sure the object is fully initialized.
void | uncache () FL_OVERRIDE
| If the image has been cached for display, delete the cache data.
| ~Fl_RGB_Image () FL_OVERRIDE
| The destructor frees all memory and server resources that are used by the image.
Public Member Functions inherited from Fl_Image
virtual class Fl_Shared_Image * | as_shared_image ()
| Returns whether an image is an Fl_Shared_Image or not.
Fl_Image * | copy () const
| Creates a copy of the image in the same size.
int | count () const
| Returns the number of data values associated with the image.
int | d () const
| Returns the image depth.
const char *const * | data () const
| Returns a pointer to the current image data array.
int | data_h () const
| Returns the height of the image data.
int | data_w () const
| Returns the width of the image data.
void | draw (int X, int Y)
| Draws the image to the current drawing surface.
int | fail () const
| Returns a value that is not 0 if there is currently no image available.
| Fl_Image (int W, int H, int D)
| The constructor creates an empty image with the specified width, height, and depth.
int | h () const
| Returns the current image drawing height in FLTK units.
void | inactive ()
| The inactive() method calls color_average(FL_BACKGROUND_COLOR, 0.33f) to produce an image that appears grayed out.
int | ld () const
| Returns the current line data size in bytes.
virtual void | release ()
| Releases an Fl_Image - the same as '`delete` `this'`.
virtual void | scale (int width, int height, int proportional=1, int can_expand=0)
| Sets the drawing size of the image.
int | w () const
| Returns the current image drawing width in FLTK units.
virtual | ~Fl_Image ()
| The destructor is a virtual method that frees all memory used by the image.

## Static Public Member Functions
static size_t | max_size ()
| Returns the maximum allowed image size in bytes when creating an Fl_RGB_Image object.
static void | max_size (size_t size)
| Sets the maximum allowed image size in bytes when creating an Fl_RGB_Image object.
Static Public Member Functions inherited from Fl_Image
static Fl_Labeltype | define_FL_IMAGE_LABEL ()
static Fl_RGB_Scaling | RGB_scaling ()
| Returns the currently used RGB image scaling method.
static void | RGB_scaling (Fl_RGB_Scaling)
| Sets the RGB image scaling method used for copy(int, int).
static Fl_RGB_Scaling | scaling_algorithm ()
| Gets what algorithm is used when resizing a source image to draw it.
static void | scaling_algorithm (Fl_RGB_Scaling algorithm)
| Sets what algorithm is used when resizing a source image to draw it.

## Public Attributes
int | alloc_array
| If non-zero, the object's data array is delete[]'d when deleting the object.
const uchar * | array
| Points to the start of the object's data array.

## Friends
class | Fl_Graphics_Driver

## Additional Inherited Members
Static Public Attributes inherited from Fl_Image
static const int | ERR_FILE_ACCESS = -2
static const int | ERR_FORMAT = -3
static const int | ERR_MEMORY_ACCESS = -4
static const int | ERR_NO_IMAGE = -1
static bool | register_images_done = false
| True after fl_register_images() was called, false before.
Protected Member Functions inherited from Fl_Image
void | d (int D)
| Sets the current image depth.
void | data (const char *const *p, int c)
| Sets the current data pointer and count of pointers in the array.
void | draw_empty (int X, int Y)
| The protected method draw_empty() draws a box with an X in it.
int | draw_scaled (int X, int Y, int W, int H)
| Draw the image to the current drawing surface rescaled to a given width and height.
void | h (int H)
| Sets the height of the image data.
void | ld (int LD)
| Sets the current line data size in bytes.
void | w (int W)
| Sets the width of the image data.
Static Protected Member Functions inherited from Fl_Image
static void | labeltype (const Fl_Label *lo, int lx, int ly, int lw, int lh, Fl_Align la)
static void | measure (const Fl_Label *lo, int &lw, int &lh)

## Detailed Description

The Fl_RGB_Image class supports caching and drawing of full-color images with 1 to 4 channels of color information.

Images with an even number of channels are assumed to contain alpha information, which is used to blend the image with the contents of the screen.

Fl_RGB_Image is defined in <FL/Fl_Image.H>, however for compatibility reasons <FL/Fl_RGB_Image.H> should be included.

## Constructor & Destructor Documentation

## ◆ Fl_RGB_Image() [1/3]

Fl_RGB_Image::Fl_RGB_Image | ( | const uchar * | bits,
|  | int | W,
|  | int | H,
|  | int | D = 3,
|  | int | LD = 0 )

The constructor creates a new image from the specified data.

The data array `bits` must contain sufficient data to provide `W` * `H` * `D` image bytes and optional line padding, see `LD`.

`W` and `H` are the width and height of the image in pixels, resp.

`D` is the image depth and can be:

- D=1: each uchar in `bits`[] is a grayscale pixel value
- D=2: each uchar pair in `bits`[] is a grayscale + alpha pixel value
- D=3: each uchar triplet in `bits`[] is an R/G/B pixel value
- D=4: each uchar quad in `bits`[] is an R/G/B/A pixel value

`LD` specifies the line data size of the array, see Fl_Image::ld(int). If `LD` is zero, then `W` * `D` is assumed, otherwise `LD` must be greater than or equal to `W` * `D` to account for (unused) extra data per line (padding).

The caller is responsible that the image data array `bits` persists as long as the image is used.

This constructor sets Fl_RGB_Image::alloc_array to 0. To have the image object control the deallocation of the data array `bits`, set alloc_array to non-zero after construction.

Parameters

  [in] | bits | The image data array.
  [in] | W | The width of the image in pixels.
  [in] | H | The height of the image in pixels.
  [in] | D | The image depth, or 'number of channels' (default=3).
  [in] | LD | Line data size (default=0).

See also
  Fl_Image::data(), Fl_Image::w(), Fl_Image::h(), Fl_Image::d(), Fl_Image::ld(int)

## ◆ Fl_RGB_Image() [2/3]

Fl_RGB_Image::Fl_RGB_Image | ( | const uchar * | bits,
|  | int | bits_length,
|  | int | W,
|  | int | H,
|  | int | D,
|  | int | LD )

The constructor creates a new image from the specified data.

If the provided array is too small to contain all the image data, the constructor will not generate the image to avoid illegal memory read access and instead set `data` to NULL and `ld` to `ERR_MEMORY_ACCESS`.

Parameters

  bits | image data
  bits_length | length of the `bits` array in bytes
  W | image width in pixels
  H | image height in pixels
  D | image depth in bytes, 1 for gray scale, 2 for gray with alpha, 3 for RGB, and 4 for RGB plus alpha
  LD | line length in bytes, or 0 to use W*D.

See also
  Fl_RGB_Image(const uchar *bits, int W, int H, int D, int LD)

## ◆ Fl_RGB_Image() [3/3]

Fl_RGB_Image::Fl_RGB_Image | ( | const Fl_Pixmap * | pxm,
|  | Fl_Color | bg = FL_GRAY )

The constructor creates a new RGBA image from the specified Fl_Pixmap.

The RGBA image is built fully opaque except for the transparent area of the pixmap that is assigned the `bg` color with full transparency.

This constructor creates a new internal data array and sets Fl_RGB_Image::alloc_array to 1 so the data array is deleted when the image is destroyed.

## Member Function Documentation

## ◆ as_svg_image()

virtual Fl_SVG_Image * Fl_RGB_Image::as_svg_image | ( |  | ) |
| inlinevirtual

Returns whether an image is an Fl_SVG_Image or not.

This virtual method returns a pointer to the Fl_SVG_Image if this object is an instance of Fl_SVG_Image or NULL if not.

Reimplemented in Fl_SVG_Image.

## ◆ color_average()

void Fl_RGB_Image::color_average | ( | Fl_Color | c,
|  | float | i )
| virtual

The color_average() method averages the colors in the image with the provided FLTK color value.

The first argument specifies the FLTK color to be used.

The second argument specifies the amount of the original image to combine with the color, so a value of 1.0 results in no color blend, and a value of 0.0 results in a constant image of the specified color.

An internal copy is made of the original image data before changes are applied, to avoid modifying the original image data in memory.

Reimplemented from Fl_Image.

Reimplemented in Fl_SVG_Image.

## ◆ copy()

Fl_Image * Fl_RGB_Image::copy | ( | int | W,
|  | int | H ) const
| virtual

Creates a resized copy of the image.

It is recommended not to call this member function to reduce the size of an image to the size of the area where this image will be drawn, and to use Fl_Image::scale() instead.

The new image should be released when you are done with it.

Note: since FLTK 1.4.0 you can use Fl_Image::release() for all types of images (i.e. all subclasses of Fl_Image) instead of operator delete for Fl_Image's and Fl_Image::release() for Fl_Shared_Image's.

The new image data will be converted to the requested size. RGB images are resized using the algorithm set by Fl_Image::RGB_scaling().

For the new image the following equations are true:

- w() == data_w() == `W`
- h() == data_h() == `H`

Parameters

  [in] | W,H | Requested width and height of the new image

Note
  The returned image can be safely cast to the same image type as that of the source image provided this type is one of Fl_RGB_Image, Fl_SVG_Image, Fl_Pixmap, Fl_Bitmap, Fl_Tiled_Image, Fl_Anim_GIF_Image and Fl_Shared_Image. Returned objects copied from images of other, derived, image classes belong to the parent class appearing in this list. For example, the copy of an Fl_GIF_Image is an object of class Fl_Pixmap.
  Since FLTK 1.4.0 this method is 'const'. If you derive your own class from Fl_Image or any subclass your overridden methods of 'Fl_Image::copy() const' and 'Fl_Image::copy(int, int) const' must also be 'const' for inheritance to work properly. This is different than in FLTK 1.3.x and earlier where these methods have not been 'const'.

Reimplemented from Fl_Image.

Reimplemented in Fl_SVG_Image.

## ◆ desaturate()

void Fl_RGB_Image::desaturate | ( |  | ) |
| virtual

The desaturate() method converts an image to grayscale.

If the image contains an alpha channel (depth = 4), the alpha channel is preserved.

An internal copy is made of the original image data before changes are applied, to avoid modifying the original image data in memory.

Reimplemented from Fl_Image.

Reimplemented in Fl_SVG_Image.

## ◆ draw()

void Fl_RGB_Image::draw | ( | int | X,
|  | int | Y,
|  | int | W,
|  | int | H,
|  | int | cx = 0,
|  | int | cy = 0 )
| virtual

Draws the image to the current drawing surface with a bounding box.

Arguments X,Y,W,H specify a bounding box for the image, with the origin (upper-left corner) of the image offset by the `cx` and `cy` arguments.

Another way to see what part of the image gets drawn and where, is to consider this alternative writing producing the same output:

    fl_push_clip(X,Y,W,H);
    this->draw(X - cx, Y - cy);
    fl_pop_clip();

Repeated calls to this member function with the same image but varying W, H, cx, or cy arguments may be more efficiently processed using the above alternative writing.

Reimplemented from Fl_Image.

Reimplemented in Fl_SVG_Image.

## ◆ label() [1/2]

void Fl_RGB_Image::label | ( | Fl_Menu_Item * | m | ) |
| virtual

This method is an obsolete way to set the image attribute of a menu item.

Deprecated
  Please use Fl_Menu_Item::image() instead.

Reimplemented from Fl_Image.

## ◆ label() [2/2]

void Fl_RGB_Image::label | ( | Fl_Widget * | widget | ) |
| virtual

This method is an obsolete way to set the image attribute of a widget or menu item.

Deprecated
  Please use Fl_Widget::image() or Fl_Widget::deimage() instead.

Reimplemented from Fl_Image.

## ◆ max_size() [1/2]

size_t Fl_RGB_Image::max_size | ( |  | ) |
| inlinestatic

Returns the maximum allowed image size in bytes when creating an Fl_RGB_Image object.

See also
  void Fl_RGB_Image::max_size(size_t)

## ◆ max_size() [2/2]

void Fl_RGB_Image::max_size | ( | size_t | size | ) |
| inlinestatic

Sets the maximum allowed image size in bytes when creating an Fl_RGB_Image object.

The image size in bytes of an Fl_RGB_Image object is the value of the product w() * h() * d(). If this product exceeds size, the created object of a derived class of Fl_RGB_Image won't be loaded with the image data. This does not apply to direct RGB image creation with Fl_RGB_Image::Fl_RGB_Image(const uchar *bits, int W, int H, int D, int LD). The default max_size() value is essentially infinite.

## ◆ normalize()

virtual void Fl_RGB_Image::normalize | ( |  | ) |
| inlinevirtual

Makes sure the object is fully initialized.

In particular, makes sure member variable array is non-null.

Reimplemented in Fl_SVG_Image.

## ◆ uncache()

void Fl_RGB_Image::uncache | ( |  | ) |
| virtual

If the image has been cached for display, delete the cache data.

This allows you to change the data used for the image and then redraw it without recreating an image object.

Reimplemented from Fl_Image.

## Member Data Documentation

## ◆ array

const uchar* Fl_RGB_Image::array

Points to the start of the object's data array.

See also
  class Fl_SVG_Image which delays initialization of this member variable.

The documentation for this class was generated from the following files:

- Fl_Image.H
- Fl_Image.cxx